stages:
  - build
  - package
  - test
  - staging
  - production

build:
  stage: build
  image: adoptopenjdk/openjdk11-openj9:x86_64-ubuntu-jdk-11.0.3_7_openj9-0.14.3
  before_script:
    - apt-get update
    - apt-get install -y curl software-properties-common
  script:
    - sh gradlew clean build bootjar
  artifacts:
    untracked: true
    expire_in: 1 day
    when: always

test:
  image: ruby:2.4
  stage: test
  script:
    - apt-get update -yq
    - apt-get install -y ruby-dev
    - gem install dpl
    - dpl --provider=heroku --app=time-job-test --api-key=$HEROKU_APIKEY
  only:
    - test

deploy_staging:
  image: ruby:2.4
  stage: staging
  script:
    - apt-get update -yq
    - apt-get install -y ruby-dev
    - gem install dpl
    - cat Procfile
    - dpl --provider=heroku --app=time-job-staging --api-key=$HEROKU_APIKEY
  only:
    - develop


deploy_production:
  image: ruby:2.4
  stage: production
  script:
    - apt-get update -yq
    - apt-get install -y ruby-dev
    - gem install dpl
    - dpl --provider=heroku --app=time-job-production --api-key=$HEROKU_APIKEY
  only:
    - master

